/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef FILELISTICONS_HPP
#define FILELISTICONS_HPP

#include "FileIcon.hpp"
#include "Status.hpp"
#include "Question.hpp"
#include "QuestionManager.hpp"
#include <vector>
#include "Cancelable.hpp"


struct Header
{
string name;
int width;
};

/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/
class FileListIcons : public QuestionManager
{
public:

	virtual FileIcon getCurrentFileIcon()=0;
	virtual void addFileIcon(FileIcon fileIcon)=0;
	virtual void addFileIcons( vector<FileIcon> fileIcons)=0;
	virtual void replaceFileIcon(int position,FileIcon)=0;
	virtual void removeFileIcon(int position)=0;
	virtual FileIcon getFileIcon(int position)=0;
	virtual void clearItems(void)=0;
	virtual bool isFileIconSelected(void)=0;
	virtual void setHeaders(vector<Header>)=0;
	virtual vector<FileIcon>getSelectedFileIcons()=0;
	virtual Status* getStatusPanel(Cancelable *cancelable)=0;
	virtual void setView(string fileListStyle)=0;
	virtual void setTextFieldList(vector<string>)=0;
	virtual void setTextFieldCommands(vector<string>)=0;
	virtual void setStatusInfo(string text, string iconName="")=0;
	virtual void switchPanelsView(void)=0;
	virtual void setFocus()=0;
	virtual void selectAll()=0;
	virtual void selectFileIcon(int position)=0;
	virtual void startProcessing()=0;
	virtual void stopProcessing()=0;
	virtual int loadPreviewIcon(string file, int size)=0;
    	virtual void unloadPreviewIcons()=0;
    	virtual void disable()=0;
    	virtual void enable()=0;
    	virtual bool isProcessing()=0;
    	virtual void createPanel(string name, string param )=0;
    	virtual void ask(WindowContent *windowContent,map<string,string> &result)=0;
    	virtual void clipboardCopy(bool cut=false)=0;
	virtual void clipboardPaste()=0;

};

#endif
