/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "Mime.hpp"
#include "xdgmime/xdgmime.h"
#include <iostream>
using namespace std;

Mime::Mime()
: settings(singleton<Settings>::instance())
{
	
}


Mime::~Mime()
{
}

string Mime::getFileMime(path file,bool local)
{
	string name;
	const char *m;
	
	if(local)
	{
		m=xdg_mime_get_mime_type_for_file (file.string().c_str(), NULL);
	}
	else
	{
		m=xdg_mime_get_mime_type_from_file_name (file.string().c_str());
	}
	
	if(m)	
	name=m;

	return name;
}

string Mime::getParentMime(MimeInfo mimeInfo)
{
	string name=mimeInfo.getName();
	int pos=name.find ("/");	
		if(pos!=-1)
		{
			name=name.substr(0,pos);
			return name;
		}
		else
			return "";	
}

string Mime::getParentMime(string name)
{
	int pos=name.find ("/");	
		if(pos!=-1)
		{
			name=name.substr(0,pos);
			return name;
		}
		else
			return "";
}


