/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef MIMEINFO_HPP
#define MIMEINFO_HPP

/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/

#include <string>
#include <vector>
#include <map>
using namespace std;

class MimeInfo
{
public:
	MimeInfo():empty(true){}
    	explicit MimeInfo(string name);
    	~MimeInfo();
    	map< string, vector<string> > getMap(void);
    	static MimeInfo CreateEmpty(string name);

	void setIcon(const string& theValue)
	{
	    icon = theValue;
	}
	

	string getIcon() const
	{
	    return icon;
	}

	void setDefaultCommand(const string& theValue)
	{
	    defaultCommand = theValue;
	}
	

	string getDefaultCommand() const
	{
		return defaultCommand;	    			
	}

	bool isSubMime() const
	{
	    return subMime;
	}

	string getName() const
	{
	    return name;
	}

	bool isEmpty() const
	{
	    return empty;
	}

	void setEmpty(bool theValue)
	{
	    empty = theValue;
	}

	void setCommands ( const vector< string >& theValue )
	{
		commands = theValue;
	}
	

	vector< string > getCommands() const
	{
		return commands;
	}

	void setColor ( const string& theValue )
	{
		color = theValue;
	}
	

	string getColor() const
	{
		return color;
	}

	void setBackColor ( const string& theValue )
	{
		backColor = theValue;
	}
	

	string getBackColor() const
	{
		return backColor;
	}
	
	
	
	
	
	
protected:
	
	string name;
	bool empty;
	
	
private:
        
	string icon;
	string defaultCommand;
	bool subMime;
	vector<string>commands;
	string color;
	string backColor;
	

};



#endif
