/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "config.h"


#ifdef HAVE_BOOST_PYTHON



#include "FileList.hpp"
#include "PluginsEngine.hpp"
#include <boost/python.hpp>
#include <boost/python/suite/indexing/indexing_suite.hpp>
#include <boost/python/suite/indexing/vector_indexing_suite.hpp>
#include <boost/python/suite/indexing/map_indexing_suite.hpp>
using namespace boost::python;

#include <fstream>
#include <iostream>
#include <string>
#include <list>
#include <vector>
using namespace std;


/*
struct FileListIconsWrap : FileListIcons, wrapper<FileListIcons>
{

	void addFileIcon(FileIcon fileIcon)
	{
		this->get_override("addFileIcon")();
	}
	
	bool isFileIconSelected()
	{
		return this->get_override("isFileIconSelected")();
	}	
	void clearItems(void)
	{
		this->get_override("clearItems")();
	}
	void setPath(string)
	{
		this->get_override("setPath")();
	}
	void setHeaders(vector<string>)
	{
		this->get_override("setHeaders")();
	}
	vector<string> getSelectedIconNames(void)
	{
		return this->get_override("getSelectedIconNames")();
	}
	Status* getStatusPanel(void)
	{
		return this->get_override("getStatusPanel")();
	}
	Question* getQuestion(void)
	{
		return this->get_override("getQuestion")();
	}
    
    	void setView(string)
	{
		this->get_override("setView")();
	}
	
	void setFocus()
	{
		this->get_override("setFocus")();
	}
	void selectAll()
	{
		this->get_override("selectAll")();
	}
	void switchPanelsView()
	{
		this->get_override("switchPanelsView")();
	}
	void setHeaders(vector<Header>)
	{
		this->get_override("setHeaders")();
	}
	void setStatusInfo(string)
	{
		this->get_override("setStatusInfo")();
	}
	void setTextFieldList(vector<string>)
	{
		this->get_override("setTextFieldList")();
	}
	void setTextFieldCommands(vector<string>)
	{
		this->get_override("setTextFieldCommands")();
	}
	void startProcessing()
	{
		this->get_override("startProcessing")();
	}
	void stopProcessing()
	{
		this->get_override("stopProcessing")();
	}
	void replaceFileIcon(int position,FileIcon)
	{
		this->get_override("replaceFileIcon")();
	}
	FileIcon getFileIcon(int position)
	{
		this->get_override("getFileIcon")();
	}
	
};

*/

struct FileListWrap : FileList, wrapper<FileList>
{

	void openParentDir()
	{
		this->get_override("openParentDir")();
	}
	void openIcon( FileIcon fileIcon )
	{
		this->get_override("openIcon")();
	}
	void openDirectory( path p)
	{
		this->get_override("openDirectory")();
	}
	void reloadDirectory()
	{
		this->get_override("reloadDirectory")();
	}
	vector<string> getDirectories(void)
	{
		return this->get_override("getDirectories")();
	}
	void runCommand(string name,string param="")
	{
		this->get_override("runCommand")();
	}
	vector<string> getToolbarCommands(string)
	{
		return this->get_override("getToolbarCommands")();
	}
	vector<string> filterContexCommands(vector<string>)
	{
		return this->get_override("filterContexCommands")();
	} 
	Vfs* getVfs()
	{
		return this->get_override("getVfs")();
	}
	FileListIcons* getFileListIcons()
	{
		return this->get_override("getFileListIcons")();
	}
	void setOpposite(FileList* theValue)
	{
		this->get_override("setOpposite")();
	}
	void sort(int nr=-1)
	{
		this->get_override("sort")();
	}
	void textFieldExecute(string)
	{
		this->get_override("textFieldExecute")();
	}
	void textFieldCommandSwitch(int)
	{
		this->get_override("textFieldCommandSwitch")();
	}
	void clicked(void)
	{
		this->get_override("clicked")();
	}
	path getCurrentDirectory()
	{
		return this->get_override("getCurrentDirectory")();
	}
	FileList* getOpposite()
	{
		return this->get_override("getOpposite")();
	}
	void setDroppedFileNames(const vector< string >& theValue)
	{
		this->get_override("setDroppedFileNames")();
	}
	bool isDragAndDrop()
	{
		return this->get_override("isDragAndDrop")();
	}
	void setDragAndDrop(bool theValue)
	{
		this->get_override("setDragAndDrop")();
	}
	string getTextFieldData()
	{
		return this->get_override("getTextFieldData")();
	}
	string getVfsName()
	{
		return this->get_override("getVfsName")();
	}
	string getVfsType()
	{
		return this->get_override("getVfsType")();
	}
	FileList* getFileListSync()
	{
		return this->get_override("getFileListSync")();
	}
	void setFileListSync ( FileList* theValue )
	{
		this->get_override("setFileListSync")();
	}
	void stopThreadProcessing(ThreadCommand *tc)
	{
		this->get_override("stopThreadProcessing")();
	}
	void startThreadProcessing(ThreadCommand *tc)
	{
		this->get_override("startThreadProcessing")();
	}
	void setCurrentDirectory(const path& theValue)
	{
		this->get_override("setCurrentDirectory")();
	}
	path getNewDirectory()
	{	
		return this->get_override("getNewDirectory")();
	}
	void waitForThreads()
	{	
		this->get_override("waitForThreads")();
	}
	vector< string >& getPathHistory()
	{	
		return this->get_override("getPathHistory")();
	}
	vector< string > getAvailableCommandsForSelectedFiles()
	{	
		return this->get_override("getAvailableCommandsForSelectedFiles")();
	}
	path accessFile(path filePath)
	{	
		return this->get_override("accessFile")();
	}
	void releaseFile(path filePath, bool commit=true)
	{	
		this->get_override("accessFile")();
	}
	vector<path> getSelectedFileIconsPaths()
	{	
		return this->get_override("getSelectedFileIconsPaths")();
	}
	vector<string> getSelectedFileIcons()
	{	
		return this->get_override("getSelectedFileIcons")();
	}
	FileIcon getCurrentFileIcon()
	{	
		return this->get_override("getCurrentFileIcon")();
	}
	FileIcon getFileIcon(string p)
	{	
		return this->get_override("getFileIcon")();
	}
	void addFileIcon(File file)
	{	
		this->get_override("addFileIcon")();
	}
	void addFile(string p)
	{	
		this->get_override("addFile")();
	}
	void setFiles(vector<File> filesVec)
	{	
		this->get_override("setFiles")();
	}
	void replaceFileIcon(FileIcon fileIcon)
	{
		this->get_override("replaceFileIcon")();
	}
	void removeFileIcon(string p)
	{
		this->get_override("removeFileIcon")();
	}
	void removeFileIcons()
	{
		this->get_override("removeFileIcons")();
	}
	void selectFileIcon(string p)
	{
		this->get_override("selectFileIcon")();
	}
	vector<string>getAllFilesPaths()
	{
		return this->get_override("getAllFilesPaths")();
	}
	void refreshFileIcon(string p)
	{
		this->get_override("refreshFileIcon")();
	}	
	void acquire()
	{
		this->get_override("acquire")();
	}
	void release()
	{
		this->get_override("release")();
	}
	bool isAcquired()
	{
		return this->get_override("isAcquired")();
	}
	void tick()
	{
		this->get_override("tick")();
	}
	
	

};

BOOST_PYTHON_MODULE(NaoPluginEngine) 
{

  class_<FileListWrap,boost::noncopyable>("FileList")
.def("openParentDir",&FileList::openParentDir)
.def("openIcon",&FileList::openIcon)
.def("openDirectory",&FileList::openDirectory)
.def("reloadDirectory",&FileList::reloadDirectory)
.def("getDirectories",&FileList::getDirectories)
.def("runCommand",&FileList::runCommand)
.def("getToolbarCommands",&FileList::getToolbarCommands)
.def("filterContexCommands",&FileList::filterContexCommands)
.def("sort",&FileList::sort)
.def("textFieldExecute",&FileList::textFieldExecute)
.def("textFieldCommandSwitch",&FileList::textFieldCommandSwitch)
.def("clicked",&FileList::clicked)
.def("getCurrentDirectory",&FileList::getCurrentDirectory)
.def("setDroppedFileNames",&FileList::setDroppedFileNames)
.def("isDragAndDrop",&FileList::isDragAndDrop)
.def("setDragAndDrop",&FileList::setDragAndDrop)
.def("getTextFieldData",&FileList::getTextFieldData)
.def("getVfsName",&FileList::getVfsName)
.def("getVfsType",&FileList::getVfsType)
.def("setCurrentDirectory",&FileList::setCurrentDirectory)
.def("getNewDirectory",&FileList::getNewDirectory)
.def("getAvailableCommandsForSelectedFiles",&FileList::getAvailableCommandsForSelectedFiles)
.def("accessFile",&FileList::accessFile)
.def("releaseFile",&FileList::releaseFile)
.def("getAllFilesPaths",&FileList::getAllFilesPaths)
.def("getSelectedFileIcons",&FileList::getSelectedFileIcons)
.def("getCurrentFileIcon",&FileList::getCurrentFileIcon)
.def("getFileIcon",&FileList::getFileIcon)
.def("setFiles",&FileList::setFiles)
.def("replaceFileIcon",&FileList::replaceFileIcon)
.def("removeFileIcon",&FileList::removeFileIcon)
.def("removeFileIcons",&FileList::removeFileIcons)
.def("selectFileIcon",&FileList::selectFileIcon)
.def("addFileIcon",&FileList::addFileIcon)
.def("addFile",&FileList::addFile)
.def("refreshFileIcon",&FileList::refreshFileIcon);
//*/

    
/*TODO .def("addFileIcon",&FileList::addFileIcon)*/    
/*TODO .def("waitForThreads",&FileList::waitForThreads)*/
/*TODO .def("stopThreadProcessing",&FileList::stopThreadProcessing)*/
/*TODO .def("startThreadProcessing",&FileList::startThreadProcessing)*/    
/*TODO getVfs*/
/*TODO getFileListIcons*/
/*TODO setOpposite*/
/*TODO .def("getOpposite",&FileList::getOpposite)*/
/*
  .def("getFileListSync",&FileList::getFileListSync)
.def("setFileListSync",&FileList::setFileListSync)  
    
*/
    
  class_<vector<string> >("StringVec")
     .def(vector_indexing_suite<vector<string>,true >());
     
  class_<map<string,string> >("StringMap")
     .def(map_indexing_suite<map<string,string>,true >());   
    
   class_<FileIcon>("FileIcon")
	.def("setShowName", &FileIcon::setShowName)
	.def("getShowName", &FileIcon::getShowName)
	.def("setIconName", &FileIcon::setIconName)
	.def("getIconName", &FileIcon::getIconName)
	.def("getFile", &FileIcon::getFile)
	.def("setExtraIconName", &FileIcon::setExtraIconName)
	.def("getExtraIconName", &FileIcon::getExtraIconName)
	.def("setPreviewIcon", &FileIcon::setPreviewIcon)
	.def("getPreviewIcon", &FileIcon::getPreviewIcon)
	.def("setFile", &FileIcon::setFile)
	.def("setBackColor", &FileIcon::setBackColor)
	.def("getBackColor", &FileIcon::getBackColor)
	.def("setColor", &FileIcon::setColor)
	.def("getColor", &FileIcon::getColor);

class_<Question>("Question")
	.def("askStringQ", &Question::askStringQ)
	.def("askCustomQ", &Question::askCustomQ)
	.def("askYesNoQ", &Question::askYesNoQ)
	.def("displayErrorQ", &Question::displayErrorQ);



class_<WindowContent>("WindowContent")
	.def("setSize", &WindowContent::setSize)
	.def("addWidgetVerticalFrame", &WindowContent::addWidgetVerticalFrame)
	.def("addWidgetHorizontalFrame", &WindowContent::addWidgetHorizontalFrame)
	.def("addWidgetGroupBox", &WindowContent::addWidgetGroupBox)
	.def("addWidgetCheckButton", &WindowContent::addWidgetCheckButton)
	.def("addWidgetLabel", &WindowContent::addWidgetLabel)
	.def("addWidgetTextField", &WindowContent::addWidgetTextField)
	.def("addWidgetButton", &WindowContent::addWidgetButton)
	.def("addWidgetComboBox", &WindowContent::addWidgetComboBox)
	.def("setWidgetFocus", &WindowContent::setWidgetFocus)
	.def("setTitle", &WindowContent::setTitle)
	.def("setDefaultButton", &WindowContent::setDefaultButton);


class_<path>("path")
.def("native_directory_string", &path::native_directory_string)
.def("leaf", &path::leaf);

class_<File>("File")
.def("setName", &File::setName)
.def("getName", &File::getName)
.def("isDirectory", &File::isDirectory)
.def("setDirectory", &File::setDirectory)
.def("isSymlink", &File::isSymlink)
.def("setSize", &File::setSize)
.def("getSize", &File::getSize)
.def("setUid", &File::setUid)
.def("getUid", &File::getUid)
.def("setGid", &File::setGid)
.def("getGid", &File::getGid)
.def("setUser", &File::setUser)
.def("getUser", &File::getUser)
.def("setGroup", &File::setGroup)
.def("getGroup", &File::getGroup)
.def("setFields", &File::setFields)
.def("setParentDirectory", &File::setParentDirectory)
.def("getParentDirectory", &File::getParentDirectory)
.def("getPath", &File::getPath)
.def("setSymlink", &File::setSymlink)
.def("getSymlink", &File::getSymlink)
.def("setMime", &File::setMime)
.def("getMime", &File::getMime)	
.def("isExecutable", &File::isExecutable)
.def("setMode", &File::setMode)
.def("isUserExecutable", &File::isUserExecutable)
.def("getMode", &File::getMode)
.def("isOwnerExecutable", &File::isOwnerExecutable)
.def("setOwnerExecutable", &File::setOwnerExecutable)
.def("isOwnerReadable", &File::isOwnerReadable)	
.def("setOwnerReadable", &File::setOwnerReadable)	
.def("isOwnerWritable", &File::isOwnerWritable)	
.def("setOwnerWritable", &File::setOwnerWritable)	
.def("isGroupReadable", &File::isGroupReadable)	
.def("setGroupReadable", &File::setGroupReadable)
.def("isGroupWritable", &File::isGroupWritable)	
.def("setGroupWritable", &File::setGroupWritable)
.def("isGroupExecutable", &File::isGroupExecutable)	
.def("setGroupExecutable", &File::setGroupExecutable)	
.def("isOtherExecutable", &File::isOtherExecutable)	
.def("setOtherExecutable", &File::setOtherExecutable)	
.def("isOtherReadable", &File::isOtherReadable)	
.def("setOtherReadable", &File::setOtherReadable)	
.def("setOtherWritable", &File::setOtherWritable)	
.def("isOtherWritable", &File::isOtherWritable)	
.def("setUID", &File::setUID)	
.def("isUID", &File::isUID)
.def("setGID", &File::setGID)	
.def("isGID", &File::isGID)	
.def("setSticky", &File::setSticky)	
.def("isSticky", &File::isSticky)
.def("setAccessTime", &File::setAccessTime)
.def("getAccessTime", &File::getAccessTime)
.def("setModificationTime", &File::setModificationTime)
.def("getModificationTime", &File::getModificationTime)
.def("setCreationTime", &File::setCreationTime)
.def("getCreationTime", &File::getCreationTime)	
.def("isCharacterDevice", &File::isCharacterDevice)	
.def("setCharacterDevice", &File::setCharacterDevice)
.def("isBlockDevice", &File::isBlockDevice)
.def("setBlockDevice", &File::setBlockDevice)	
.def("isFifo", &File::isFifo)	
.def("setFifo", &File::setFifo)
.def("isSocket", &File::isSocket)	
.def("setSocket", &File::setSocket);










}


PluginsEngine::PluginsEngine()
{


}


PluginsEngine::~PluginsEngine()
{
}


void PluginsEngine::runPythonPlugin(string fileName,FileList * fileList)
{
boost::mutex::scoped_lock lock(muteX);
	
	
	string buf;
	string line;
	ifstream in(fileName.c_str());

	while(getline(in,line))
	buf += line+"\n";	
	
	FileList* fileListOpposite=NULL;
	
	PyThreadState*interpreter=NULL;
	
	try 
  	{
  	
  		Question question(fileList->getFileListIcons());
  		WindowContent windowContent;
  		
    		PyImport_AppendInittab( "NaoPluginEngine", &initNaoPluginEngine );
    		Py_Initialize();
	
		interpreter=Py_NewInterpreter();
		
    		object main_module((handle<>(borrowed(PyImport_AddModule("__main__")))));

    		object main_namespace = main_module.attr("__dict__");
   		object cpp_module( (handle<>(PyImport_ImportModule("NaoPluginEngine"))) );
   		main_namespace["NaoPluginEngine"] = cpp_module;
    		main_namespace["fileList"] = ptr(fileList);  	
    			
    		fileListOpposite=fileList->getOpposite();    			
    		main_namespace["fileListOpposite"] = ptr(fileListOpposite);
    		main_namespace["question"] = ptr(&question);
    		main_namespace["windowContent"] = ptr(&windowContent);
    		
        	handle<> ignored(( PyRun_String( buf.c_str(),Py_file_input,main_namespace.ptr(),main_namespace.ptr() ) ));
    	} 
  	catch( error_already_set ) 
  	{
   		PyErr_Print();
  	}
	
	if(!interpreter)
	Py_EndInterpreter(interpreter);
	
	//Py_Finalize();
	
	if(fileListOpposite)
	fileListOpposite->release();
	
}


#endif
