/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef XMLREADERWRITER_HPP
#define XMLREADERWRITER_HPP


#include <libxml/parser.h>
#include <libxml/xpath.h>
#include <string>
#include <map>
#include <vector>

#include "boost/filesystem/path.hpp"

using namespace boost::filesystem;
using namespace std;


/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/
class XmlReaderWriter
{
public:
    XmlReaderWriter(bool save=true);
    XmlReaderWriter( XmlReaderWriter & conf );
    ~XmlReaderWriter();
    void loadXml(path xmlFileName);    
    string read(string name);
    bool readNode ( map<string,string> &node );
    bool readNodeVector ( map<string,vector<string> > &node );
    bool writeNode (string path,string name, map<string,string> node );
    bool writeNodeVector( string path,string name, map< string, vector<string> >  node );
    bool readNodeString(string &name);
    bool openPath ( string path );
    bool addNodeString ( string path, string node, string value="" );
    bool clear();

	void setXmlFileName ( const path& theValue )
	{
		xmlFileName = theValue;
	}
	

	path getXmlFileName() const
	{
		return xmlFileName;
	}
	

    
private:

    xmlDocPtr doc;    
    xmlXPathObjectPtr result;
    xmlNodeSetPtr nodeset;
    xmlNodePtr cur;   
    int pos; 
    bool copy;
    path xmlFileName;
    bool save;

};

#endif
