/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
 
#ifndef FOXFILELISTITEM_HPP
#define FOXFILELISTITEM_HPP

#include <fx.h>
#include "FileIcon.hpp"
#include <vector>
using namespace std;


/**
	@author Mateusz Dworak aka compbatant <m@nao.linux.pl>
*/
class FoxFileListItem : public FXIconItem
{
FXDECLARE(FoxFileListItem);

public:
    FoxFileListItem(){}
    FoxFileListItem(FileIcon fileIcon,FXIcon *icon1, FXIcon *icon2,FXApp *app,FXIcon *extraIcon);
    ~FoxFileListItem();

	FileIcon getFileIcon() const
	{
	    return fileIcon;
	}
	
protected:

	void drawBigIcon( const FXIconList* list, FXDC& dc, FXint x, FXint y, FXint w, FXint h ) const;
	void drawMiniIcon(const FXIconList* list,FXDC& dc,FXint x,FXint y,FXint w,FXint h) const;
	void drawDetails(const FXIconList* list,FXDC& dc,FXint x,FXint y,FXint,FXint h) const;
	FXint hitItem ( const FXIconList * list, FXint rx, FXint ry, FXint rw, FXint rh ) const;
    	FXint getHeight ( const FXIconList * list ) const;

	


private:

	FileIcon fileIcon;
	mutable vector<string>fields;
	mutable vector<string>::iterator fieldIter;
	FXFont *fontNormal;
	FXFont *fontBig;
	FXFont *fontSmall;
	FXColor color;
	FXColor backcolor;
	FXIcon *extraIcon;

};

#endif
