/***************************************************************************
 *   Copyright (C) 2007 by Mateusz Dworak aka compbatant                   *
 *   compbatant@linux.pl                                                   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "FoxFonts.hpp"
#include "../Settings.hpp"
#include <iostream>


FoxFonts::~FoxFonts()
{
	/*SEGFAULT ?*/
	/*
	for(iter=fonts.begin();iter!=fonts.end();++iter)
	{	
		//FIXME
		delete iter->second;
	}
	fonts.clear();
	*/
}

FoxFonts::FoxFonts( FXApp *app )
{
	Settings &settings=singleton<Settings>::instance();
	
	fonts["normal"]=new FXFont( app,settings.getFontDescription("normal").c_str() );
	fonts["big"]=new FXFont( app,settings.getFontDescription("big").c_str() );
	fonts["small"]=new FXFont( app,settings.getFontDescription("small").c_str() );
	
	for(iter=fonts.begin();iter!=fonts.end();++iter)
	{
		iter->second->create();
	}
	
	

}

FXFont * FoxFonts::getFont( string name )
{
	return fonts[name];	
}


